# Setup

** The setup instructions in this document are for library development only and are not required to use the Arduino library. To get started with the Arduino library, please see `README.md`. **

* Install the [PlatformIO extension](https://platformio.org/) for Visual Studio Code
* Install the PlatformIO CLI with `pip install platformio`

## Building
* Press the [build button](https://docs.platformio.org/en/latest/_images/platformio-ide-vscode-build-project.png) (checkmark icon) on the bottom toolbar of Visual Studio Code

OR

* Run the following command: `pio run`

## Running Tests
* Open the PlatformIO [Project Tasks](https://docs.platformio.org/en/latest/integration/ide/vscode.html#task-explorer) pane
* Navigate to `build` > `Custom` and press `Run All Tests`

OR

* Run the following command: `pio run -t run-all-tests`

## Releasing

The Arduino Library registry release requirements are [listed here](https://github.com/arduino/library-registry/blob/main/FAQ.md#updates).

* Create a new release branch
* Update the `CHANGELOG.md` file with any new changes for this release.
* Update the version number in the `library.properties` file.
* Push the release branch
* Create a new tag with `git tag vX.X.X` for the version number.
* Push the tag with `git push origin vX.X.X`
* Merge the release branch to `master`
