import os

Import("env")

BUILD_EXAMPLES_COMMAND_PREFIX = "pio ci -c platformio.ini -e examples -l src examples/"

env.AddCustomTarget(
    name="build-examples",
    dependencies=None,
    actions=[BUILD_EXAMPLES_COMMAND_PREFIX + dir for dir in os.listdir("examples")],
    title="Build Examples",
    description="Build all files in examples directory."
)

# This target replaces the build action in the test environment
env.AddCustomTarget(
    name="run-all-tests",
    dependencies="build-examples",
    actions=[],
    title="Run All Tests",
    description="Runs all tests."
)
